hdu4763 Theme Section

地址:http://acm.hdu.edu.cn/showproblem.php?pid=4763

题目:

Theme Section

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3491    Accepted Submission(s): 1623

Problem Description

It‘s time for music! A lot of popular musicians are invited to join us in the music festival. Each of them will play one of their representative songs. To make the programs more interesting and challenging, the hosts are going to add some constraints to the rhythm of the songs, i.e., each song is required to have a ‘theme section‘. The theme section shall be played at the beginning, the middle, and the end of each song. More specifically, given a theme section E, the song will be in the format of ‘EAEBE‘, where section A and section B could have arbitrary number of notes. Note that there are 26 types of notes, denoted by lower case letters ‘a‘ - ‘z‘.

To get well prepared for the festival, the hosts want to know the maximum possible length of the theme section of each song. Can you help us?

Input

The integer N in the first line denotes the total number of songs in the festival. Each of the following N lines consists of one string, indicating the notes of the i-th (1 <= i <= N) song. The length of the string will not exceed 10^6.

Output

There will be N lines in the output, where the i-th line denotes the maximum possible length of the theme section of the i-th song.

Sample Input

5
xy
abc
aaa
aaaaba
aaxoaaaaa

Sample Output

0
0
1
1
2

Source

2013 ACM/ICPC Asia Regional Changchun Online

思路:用所给字符串去匹配字符串EAEBE,AB可以为空

  前缀为E,后缀为E,所以很容易想到kmp的next数组(前缀和后缀的匹配情况),然后查找所有所有前缀匹配后缀的情况然后check一下即可。

  查找所有前缀和后缀匹配的情况时可以利用next进行转移。

  ans=next[ans-1]。

 1 #include <bits/stdc++.h>
 2 #define PB push_back
 3 #define MP make_pair
 4 using namespace std;
 5 typedef long long LL;
 6 typedef pair<int,int> PII;
 7 #define PI acos((double)-1)
 8 #define E exp(double(1))
 9 const int K=1e6+9;
10 int nt[K];
11 char a[K];
12
13 //参数为模板串和next数组
14 //字符串均从下标0开始
15 void kmp_next(char *T,int *nt)
16 {
17     nt[0]=0;
18     for(int i=1,j=0,m=strlen(T);i<m;i++)
19     {
20         while(j&&T[i]!=T[j])j=nt[j-1];
21         if(T[i]==T[j])j++;
22         nt[i]=j;
23     }
24 }
25
26 int main(void)
27 {
28     int t;cin>>t;
29     while(t--)
30     {
31         scanf("%s",a);
32         kmp_next(a,nt);
33         int len=strlen(a);
34         int ans=nt[len-1],ff=1;
35         while(ans)
36         {
37             for(int i=ans;i<=len-ans&&ff;i++)
38             if(nt[i]==ans)
39                 ff=0;
40             if(!ff) break;
41             ans=nt[ans-1];
42         }
43         printf("%d\n",ans);
44     }
45
46     return 0;
47 }
时间: 2024-11-09 01:59:22

hdu4763 Theme Section的相关文章

HDU4763 Theme Section 【KMP】

Theme Section Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1114    Accepted Submission(s): 579 Problem Description It's time for music! A lot of popular musicians are invited to join us in t

HDU 4763:Theme Section(KMP)

http://acm.hdu.edu.cn/showproblem.php?pid=4763 Theme Section Problem Description It's time for music! A lot of popular musicians are invited to join us in the music festival. Each of them will play one of their representative songs. To make the progr

【HDOJ 4763】 Theme Section (KMP+strstr)

[HDOJ 4763] Theme Section Theme Section Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1999    Accepted Submission(s): 947 Problem Description It's time for music! A lot of popular musicians a

hdu 4763 Theme Section (简单KMP)

Theme Section Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1184    Accepted Submission(s): 621 Problem Description It's time for music! A lot of popular musicians are invited to join us in t

【HDU 4763】Theme Section(KMP)

这题数据水的一B,直接暴力都可以过. 比赛的时候暴力过的,回头按照正法做了一发. 匹配的时候 失配函数 其实就是前缀 后缀的匹配长度,之后就是乱搞了. KMP的题可能不会很直接的出,但是KMP的思想经常渗透在很多题目里面,最近需要多练习一下. #include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int maxn = 1000005; int _next[max

HDU 4763 - Theme Section(KMP)

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=4763 题目描述: 现有一字符串S,要求在S中找到最长的子串E,使得S满足格式“EAEBE”,其中A,B可以为任意的S子串.也就是说子串E既是S的前缀也是S的后缀,同时还在S中间出现,但不与前缀E与后缀E重叠. 解题思路: 学习KMP的第一道题.KMP的详解这篇文章写得很好:http://www.cnblogs.com/c-cloud/p/3224788.html,看完应该能理解前缀后缀概念和nex

HDU 4763 Theme Section

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=4763 ------------------------------------------------------------------------------------------- 数据范围卡了$SA$但数据却没能构造到卡一些理论复杂度更高的方法 这里说一下比较靠谱的$exkmp$的做法 根据$exkmp$的$next$数组定义 我们可以用$O(n)$的时间得到一个后缀与整个串的最长公共前

Theme Section HDU - 4763(些许暴力)

题意: 求出最长公共前后缀 不能重叠  而且 这个前后缀 在串的中间也要出现一次 解析: 再明确一次next数组的意思:完全匹配的最长前后缀长度 求一遍next 然后暴力枚举就好了 #include <iostream> #include <cstdio> #include <sstream> #include <cstring> #include <map> #include <cctype> #include <set>

HDU - 4763 Theme Section (KMP的next数组的应用)

给定一个字符串,求出一个前缀A,使得字符串的构成可以表示成ABABA的形式(B可以为空串). 输出这个前缀的最大长度. KMP算法Next数组的使用. 枚举中间的每个位置,可以根据Next数组求出这个位置对应的前缀.然后暴力判断前缀与后缀是否相等即可. 如图,枚举的位置为 i,则Next[i] = j,.然后判断0~j 是否和 k~len是否是相同的. 注意要判断合法性,即前缀 + 中缀的长度不能比当前枚举的位置大,且后缀开始的位置一定要比当前枚举的位置大. 判定完Next[i]后,一定要判定N